--- dahdi-linux-3.1.0+git20230717~dfsg.orig/drivers/dahdi/dahdi-sysfs-chan.c
+++ dahdi-linux-3.1.0+git20230717~dfsg/drivers/dahdi/dahdi-sysfs-chan.c
@@ -220,7 +220,7 @@
 	chan_dbg(DEVICES, chan, "SYSFS\n");
 }
 
-static int chan_match(struct device *dev, struct device_driver *driver)
+static int chan_match(struct device *dev, DEVICE_DRIVER_CONST struct device_driver *driver)
 {
 	struct dahdi_chan *chan;
 
--- dahdi-linux-3.1.0+git20230717~dfsg.orig/drivers/dahdi/dahdi-sysfs.c
+++ dahdi-linux-3.1.0+git20230717~dfsg/drivers/dahdi/dahdi-sysfs.c
@@ -42,7 +42,7 @@
 MODULE_PARM_DESC(tools_rootdir,
 		"root directory of all tools paths (default /)");
 
-static int span_match(struct device *dev, struct device_driver *driver)
+static int span_match(struct device *dev, DEVICE_DRIVER_CONST struct device_driver *driver)
 {
 	return 1;
 }
--- dahdi-linux-3.1.0+git20230717~dfsg.orig/drivers/dahdi/xpp/xbus-sysfs.c
+++ dahdi-linux-3.1.0+git20230717~dfsg/drivers/dahdi/xpp/xbus-sysfs.c
@@ -400,7 +400,7 @@
 ATTRIBUTE_GROUPS(xbus_dev);
 #endif
 
-static int astribank_match(struct device *dev, struct device_driver *driver)
+static int astribank_match(struct device *dev, DEVICE_DRIVER_CONST struct device_driver *driver)
 {
 	DBG(DEVICES, "SYSFS MATCH: dev->bus_id = %s, driver->name = %s\n",
 	    dev_name(dev), driver->name);
@@ -764,7 +764,7 @@
 	return len;
 }
 
-static int xpd_match(struct device *dev, struct device_driver *driver)
+static int xpd_match(struct device *dev, DEVICE_DRIVER_CONST struct device_driver *driver)
 {
 	struct xpd_driver *xpd_driver;
 	xpd_t *xpd;
--- dahdi-linux-3.1.0+git20230717~dfsg.orig/include/dahdi/kernel.h
+++ dahdi-linux-3.1.0+git20230717~dfsg/include/dahdi/kernel.h
@@ -1680,4 +1680,13 @@
 #define UEVENT_CONST
 #endif
 
+/* work-around kernel API change from "struct device_driver *_drv" to
+ * "const struct device_driver *_drv"
+ * as implemented in d69d804845985c29ab5be5a4b3b1f4787893daf8 */
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(6, 11, 0)
+#define DEVICE_DRIVER_CONST const
+#else
+#define DEVICE_DRIVER_CONST
+#endif
+
 #endif /* _DAHDI_KERNEL_H */
